from resource import Oxygen, Power
from position import Position
from enum import Enum


class Module:

    def __init__(self, name, oxygen=Oxygen(), power=Power(), parent=None, position=None):
        self.name = name
        self.Oxygen = oxygen
        self.Power = power
        self.Parent = parent
        self.Position = position
        self.Connections = []


class Connection:
    class Direction(Enum):
        A_TO_B = 1
        B_TO_A = 2
        TWO_WAY = 0

    def __init__(self,
                 from_module: Module,
                 to_module: Module,
                 resources: list,
                 direction: Direction = Direction.A_TO_B):
        self.FROM = from_module
        self.TO = to_module
        self.RESOURCES = resources
        self.DIRECTION = direction


class Core(Module):

    def __init__(self, station_name, name):
        super().__init__(name)
        self.name = station_name
        self.Power.rate = 50
        self.Modules = []
        self.Parent = self

    def __str__(self):
        return f"{self.name}: {self.Oxygen.amount} Oxygen, {self.Power.amount} Power"
